% Exercise 6 (Transient temperature in a sedimentary basin)

% Define the input paramters: Initial T (T0), thermal gradient (G),
% sedimentary thickness (y), (thickness of the layer sedimented or eroded),
% time (t)

T0=10;
G=25*10^-3;
y=[0:10:5000];
l=[1000];
t=[0:10^3:5*10^5];
k=10^-6;

% Initialize the Temperature matrices 

MagTrT1=zeros(501,501);
MagTrT2=zeros(501,501);

% Estimate the temperature (T1 and T2) in case of erosion(1mm/yr)and
% sedimentation (1mm/yr=1m/1kyr)every 100 m

for i=1:501
    
T1=T0+G.*(y(i)+l)-G.*l.*erfc(y(i)./(2.*sqrt((t.*3600.*24.*365).*k)));
MagTrT1(i,:)=T1;

T2=T0+G.*(y(i)-l)+G.*l.*erfc(y(i)./(2.*sqrt((t.*3600.*24.*365).*k)));
MagTrT2(i,:)=T2;

end

% Estimate the temperature in a steady state conditions
TSteadState=T0+G.*(y)+G.*erfc(y./(2.*sqrt((0.*3600.*24.*365).*k)));

% Plot the results (transient T for erosion)

figure
subplot(1,2,1);
plot(TSteadState,y.*-1,'LineWidth',2)

for j=101:100:501
 hold on
plot(MagTrT1(:,j),y.*-1,'LineWidth',2)

% Create xlabel
xlabel('Temperature (C)','FontSize',20,'FontWeight','bold');
% Create ylabel
ylabel('Depth (km)','FontSize',20,'FontWeight','bold');
title(['Transient T for erosion  of 1km of sediments'],'FontSize',20)
end

% Plot the results (transient T for sedimentation)

% figure
subplot(1,2,2);
plot(TSteadState,y.*-1,'LineWidth',2)

for j=101:100:501
hold on
plot(MagTrT2(:,j),y.*-1,'LineWidth',2)

% Create xlabel
xlabel('Temperature (C)','FontSize',20,'FontWeight','bold');
% Create ylabel
ylabel('Depth (km)','FontSize',20,'FontWeight','bold');
title(['Transient T for a sedimentation of 1km of sediments'],'FontSize',20)

end
