% Es.1 Utilizzare i dati della tabella sottostante per fare un plot del calore 
% radiogenico vs il flusso di calore superficiale (Q0) e interpolare i valori
% linearmente per ottenere il flusso di calore ridotto (Qr, l’intercetta  sul-
% l’asse Q0) e la costante di profondita’ del calore radiogenico (ar o D, 
% pendenza della retta di interpolazione).
% (in cooperation with Francesca Maddaloni)

x=[8.7 8.8 7.4 5.4 4.9 4.0 3.3 1.6]*10^-6;
y=[95.0 90.0 79.1 75.3 68.2 68.2 56.1 45.2]*10^-3;

%fit
ft = fittype('poly1');
[fitresult, gof] = fit(x',y',ft);

figure
plot(fitresult,x,y);
xlabel('A0');
ylabel('Q0');
title('calore radiogenico vs flusso di calore superficiale');

D  = fitresult.p1; % costante di profondità
Qr = fitresult.p2; % flusso ridotto
disp(['D = ',num2str(D),', Qr = ',num2str(Qr)]);

% Es.2 Utilizzare i risultati ottenuti dal primo esercizio (Qr e D) e i 
% valori medi della retta di interpolazione (Qo e Ao) per 
% calcolare la geoterma tra 0 e 35 km di profondita’ con un intervalo di 
% 0.5 km, considerando la prima volta il calore radiogenico constante (Ao) 
% e successivamente che la sua variazione con la profondita’ e’ approssimato 
% da una funzione esponenziale.


x1= [0,max(x)];
y1=interp1(x,y,x1,'linear','extrap');

% Define A
A1=0.1*10^-6;
% Qo=mean(y1);%valori medi della retta di interpolazione (Qo e Ao)
Qo=70*10^-3;

z=0:5e2:35e3; %profondita calcolo geoterma (m)

T0=0; % T iniziale
K=3.0; %conduttività termica inziale
  
%a. Considerando il calore radiogenico costante, la geoterma: 
Tz1= T0+((Qo/K).*z)-((A1/2*K).*z.^2);
figure
plot(Tz1,z.*-1)
hold on
Tz0= T0+((Qo/K).*z);
plot(Tz0,z.*-1)

% Create xlabel
xlabel('Tz1 (C)','FontSize',20,'FontWeight','bold');

% Create ylabel
ylabel('Depth (m)','FontSize',20,'FontWeight','bold');


% Risolvendo per Qm
zc=35000;
Tz1a= T0+(((Qr+A1*zc)/K).*z)-((A1/2*K).*z.^2);
figure
plot(Tz1a,-z)


% Create xlabel
xlabel('Tz1a (C)','FontSize',20,'FontWeight','bold');

% Create ylabel
ylabel('Depth (m)','FontSize',20,'FontWeight','bold');


%b.Considerando la variazione del calore radiogenico con la profondit
% approssimato da una funzione esponenziale
% Define A0
Ao=2.5*10^-6;

A=Ao*exp(-z/D);
qo=Qr+(Ao.*D);

figure
plot(A,-z)

% Create xlabel
xlabel('Radiogenic heat (microW/m3)','FontSize',20,'FontWeight','bold');

% Create ylabel
ylabel('Depth (m)','FontSize',20,'FontWeight','bold');

Tz2= T0+((D^2*Ao)/K)*(1-exp(-z/D))+(Qr/K).*z; 
Tz2=[Tz2];
figure
plot (Tz2,-z);


% Create xlabel
xlabel('Tz2 (C)','FontSize',20,'FontWeight','bold');

% Create ylabel
ylabel('Depth (m)','FontSize',20,'FontWeight','bold');


% o come funzione del gradiente di temperatura iniziale (T0=0, T0`=20°C/km)
 
To=20*10^-3;
Tm=To-((Ao*D)/K);
TD=(Ao*D^2)/K;

Tz3= T0+TD*(1-exp(-z/D))+Tm.*z;
figure
plot(Tz3,-z);

% Create xlabel
xlabel('Tz3 (C)','FontSize',20,'FontWeight','bold');

% Create ylabel
ylabel('Depth (m)','FontSize',20,'FontWeight','bold');










